## seqan-needle 1.0.3+ds

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

# Define the application name and version.
project (needle
         LANGUAGES CXX
         VERSION 1.0.3
         DESCRIPTION "A fast and space-efficient pre-filter for estimating the quantification of very large collections of nucleotide sequences"
         HOMEPAGE_URL "https://github.com/seqan/needle"
)

set (NEEDLE_ARGPARSE_VERSION
     "${needle_VERSION}"
     CACHE STRING "Needle version to display in the help message."
)
set (NEEDLE_ARGPARSE_DATE
     "2024-11-07"
     CACHE STRING "Needle's \"Last update:\" date to display in the help message."
)

# This allows including `*.cmake` files from the `cmake` directory without specifying the full path.
list (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Specify the directories where to store the built archives, libraries and executables.
include (output_directories)

# An option to disable configuring and building the tests. Tests are enabled by default.
# If your project-name (line 8 of this file) is `app-template`, the option will be `app-template_TEST`.
# It can be used when calling CMake: `cmake .. -Dapp-template_TEST=OFF`.
# It is good practice to allow disabling tests. If another project includes your application,
# it might not want to build your tests.
option (NEEDLE_TEST "Enable testing for NEEDLE." ON)
option (NEEDLE_DOCS "Enable documentation for NEEDLE." OFF)
option (NEEDLE_PACKAGE "Enable packaging for NEEDLE." OFF)

if (NEEDLE_PACKAGE)
    set (CPM_SOURCE_CACHE "${CMAKE_CURRENT_BINARY_DIR}/vendor")
    set (CPM_USE_LOCAL_PACKAGES OFF)
    include (package)
elseif (EXISTS "${CMAKE_CURRENT_LIST_DIR}/vendor")
    set (CPM_SOURCE_CACHE "${CMAKE_CURRENT_LIST_DIR}/vendor")
endif ()

# Enable LTO if supported.
include (CheckIPOSupported)
check_ipo_supported (RESULT NEEDLE_HAS_LTO OUTPUT NEEDLE_HAS_LTO_OUTPUT)
if (NEEDLE_HAS_LTO)
    set (CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
endif ()

# Add packages.
# We use CPM for package management: https://github.com/cpm-cmake/CPM.cmake
# The added packages (e.g., hibf, sharg, seqan3) are defined in the `cmake/package-lock.cmake` file.
include (CPM)
CPMUsePackageLock (${CMAKE_CURRENT_LIST_DIR}/cmake/package-lock.cmake)

# Use ccache if available. This speeds up the build process by caching files that have been compiled before.
CPMGetPackage (use_ccache)
CPMGetPackage (seqan3)
CPMGetPackage (robin-hood)

# Add the application. This will include `src/CMakeLists.txt`.
add_subdirectory (src)

if (NEEDLE_TEST)
    list (APPEND CMAKE_CTEST_ARGUMENTS "--output-on-failure;--no-tests=error") # Must be before `enable_testing ()`.
    enable_testing ()
    add_subdirectory (test EXCLUDE_FROM_ALL)
endif ()

if (NEEDLE_DOCS)
    add_subdirectory (doc EXCLUDE_FROM_ALL)
endif ()

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

find_package (OpenMP REQUIRED COMPONENTS CXX)
add_library ("${PROJECT_NAME}_lib" STATIC estimate.cpp ibf.cpp)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC seqan3::seqan3)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC robin_hood::robin_hood)
target_link_libraries ("${PROJECT_NAME}_lib" PUBLIC OpenMP::OpenMP_CXX)
target_include_directories ("${PROJECT_NAME}_lib" PUBLIC ../include)

add_executable ("${PROJECT_NAME}" main.cpp)
target_link_libraries ("${PROJECT_NAME}" PRIVATE "${PROJECT_NAME}_lib")
set_target_properties ("${PROJECT_NAME}" PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_compile_definitions ("${PROJECT_NAME}" PRIVATE NEEDLE_VERSION="${NEEDLE_ARGPARSE_VERSION}")
target_compile_definitions ("${PROJECT_NAME}" PRIVATE NEEDLE_DATE="${NEEDLE_ARGPARSE_DATE}")

include (GNUInstallDirs)
install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

option (NEEDLE_WITH_WERROR "Report compiler warnings as errors." ON)

if (NEEDLE_WITH_WERROR)
    target_compile_options (${PROJECT_NAME}_lib PUBLIC "-Werror")
endif ()

=== test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

# This includes `cmake/test/config.cmake` which takes care of setting up the test infrastructure. It also provides
# the `add_app_test` macro, which is used to add tests to the CMake test suite.
include (test/config)

# This includes `test/data/datasources.cmake`, which makes test data available to the tests.
include (data/datasources.cmake)

add_subdirectory (api)
add_subdirectory (cli)

message (STATUS "You can run `make tests` to build tests.")
message (STATUS "You can run `make test` to run tests.")
message (STATUS "You can run `make check` to build and run tests.")

=== test/cli/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2024 Knut Reinert & Freie Universität Berlin
# SPDX-FileCopyrightText: 2016-2024 Knut Reinert & MPI für molekulare Genetik
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required (VERSION 3.25...3.30)

add_app_test (needle_options_test.cpp)
add_app_test (ibf_options_test.cpp)
add_app_test (insert_options_test.cpp)
add_app_test (minimiser_options_test.cpp)
add_app_test (estimate_options_test.cpp)
add_app_test (count_options_test.cpp)
add_app_test (delete_options_test.cpp)

=== vendor/robin-hood/1c87b2a63d3c9a4c89a4da9d2468db0e82ddd789/src/CMakeLists.txt ===
add_subdirectory(include)
add_subdirectory(test)

=== vendor/robin-hood/1c87b2a63d3c9a4c89a4da9d2468db0e82ddd789/src/external_cmake/CMakeLists.txt ===
# see https://cliutils.gitlab.io/modern-cmake/chapters/basics.html
cmake_minimum_required(VERSION 3.1...3.15)

if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()


project(MyProject VERSION 1.0
                  DESCRIPTION "Very nice project"
                  LANGUAGES CXX)
add_subdirectory("${PROJECT_SOURCE_DIR}/../.." "extern/robin_hood")

add_executable(MyProject myproject.cpp)
target_link_libraries(MyProject robin_hood)

=== vendor/robin-hood/1c87b2a63d3c9a4c89a4da9d2468db0e82ddd789/src/test/thirdparty/CMakeLists.txt ===
target_sources_local(rh PRIVATE doctest/doctest.h)

=== debian/changelog ===
seqan-needle (1.0.3+ds-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * Refreshed patches
  * d/rules: ensure that the tests are built

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Nov 2024 11:24:30 +0100

=== debian/control ===
Source: seqan-needle
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               architecture-is-64-bit,
               architecture-is-little-endian,
               cmake,
               libseqan3-dev (>= 3.2.0+ds-5),
               libgtest-dev,
               libcereal-dev,
               pkgconf,
               git,
               doxygen <!nodoc>
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/seqan-needle
Vcs-Git: https://salsa.debian.org/med-team/seqan-needle.git
Homepage: https://github.com/seqan/needle
Rules-Requires-Root: no

Package: seqan-needle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: pre-filter for the counting of very large collections of nucleotide sequences
 Needle is a tool for semi-quantitative analysis of very large collections of
 nucleotide sequences.
 .
 Needle stores its data in multiple interleaved Bloom filter, a fast and space
 efficient probabilistic data structure and uses a windowing scheme (also called
 minimisers) to reduce the amount of data to store. How many interleaved Bloom
 filter are used is defined by the user. Each interleaved Bloom filter has a so
 called expression threshold and stores minimisers with an occurrence greater
 than or equal to its own expression threshold and smaller than the next biggest
 expression threshold (if there is no bigger expression threshold, all greater
 than or equal to the threshold are stored). These expression thresholds are
 then used during the query (called estimate) to approximate the expression
 values of given transcripts.

Package: seqan-needle-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Multi-Arch: foreign
Description: HTML documentation for seqan-needle and its APIs
 Needle is a tool for semi-quantitative analysis of very large collections of
 nucleotide sequences.
 .
 Needle stores its data in multiple interleaved Bloom filter, a fast and space
 efficient probabilistic data structure and uses a windowing scheme (also called
 minimisers) to reduce the amount of data to store. How many interleaved Bloom
 filter are used is defined by the user. Each interleaved Bloom filter has a so
 called expression threshold and stores minimisers with an occurrence greater
 than or equal to its own expression threshold and smaller than the next biggest
 expression threshold (if there is no bigger expression threshold, all greater
 than or equal to the threshold are stored). These expression thresholds are
 then used during the query (called estimate) to approximate the expression
 values of given transcripts.
 .
 This package contains Needle's HTML docs.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=-O3
export DEB_CXXFLAGS_MAINT_APPEND=-O3
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure-indep:
	echo I: No configuration needed for the docs

override_dh_auto_configure-arch:
	dh_auto_configure --arch -- -DSEQAN3_NO_LEMON=OFF -DCPM_USE_LOCAL_PACKAGES=On

override_dh_auto_build-arch:
	dh_auto_build --arch -- tests

execute_after_dh_auto_build-arch:
	obj-*/bin/needle --export-help man > debian/needle.1
	obj-*/bin/needle count --export-help man > debian/needle-count.1
	obj-*/bin/needle estimate --export-help man > debian/needle-estimate.1
	obj-*/bin/needle ibf --export-help man > debian/needle-ibf.1
	obj-*/bin/needle minimiser --export-help man > debian/needle-minimiser.1

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
	doxygen doc/doxygen_cfg
endif

execute_after_dh_auto_test:
	rm -Rf obj-*/test

override_dh_auto_test-indep:
	echo I: Not running tests for the docs

=== debian/tests/control ===
Tests: run-unit-tests
Depends: @, build-essential, cmake, libseqan3-dev, libgtest-dev, libcereal-dev, git
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=\
 "searchmode=plain, \
 filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%, \
 dversionmangle=auto, \
 repacksuffix=+ds, \
 uversionmangle=s/-rc/~rc/" \
  https://api.github.com/repos/seqan/needle/releases https://github.com/seqan/needle/releases/download/(?:.*?/)?needle-@ANY_VERSION@-Source@ARCHIVE_EXT@
